import { Draft } from "immer";
import { Middleware } from "redux";
declare type PayloadAction<P> = {
    type: string;
    payload: P;
};
declare type PayloadActionDispatch<P = void> = void extends P ? () => void : (payload: P) => void;
export declare type RedurcerWithoutPayload<S> = (state: S) => S;
export declare type PayloadActionReducer<S, P = void> = (state: Draft<S>, action: PayloadAction<P>) => void | S | Draft<S>;
export declare type ReducerMap<State> = {
    [actionType: string]: PayloadActionReducer<State, any>;
};
declare type DispatcherMap<Reducers extends ReducerMap<any>> = {
    [T in keyof Reducers]: Reducers[T] extends RedurcerWithoutPayload<any> ? PayloadActionDispatch<void> : Reducers[T] extends PayloadActionReducer<any, infer P> ? PayloadActionDispatch<P> : never;
};
export interface UseLocalSliceOptions<State, Reducers extends ReducerMap<State>> {
    initialState: State;
    reducers: Reducers;
    slice?: string;
    middlewares?: Middleware[];
}
export declare function useLocalSlice<State, Reducers extends ReducerMap<State>>({ initialState, reducers, slice, middlewares }: UseLocalSliceOptions<State, Reducers>): [State, DispatcherMap<Reducers>];
export {};
